package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.UserDGTheme;
import com.sa.ibiz.demo.demo.service.UserDGThemeService;
import com.sa.ibiz.demo.demo.service.dto.UserDGThemeSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/userdgtheme")
public class UserDGThemeResource
{
	@Autowired
	private UserDGThemeService service;


	@PostMapping(value = "/update")
	public ResponseEntity<UserDGTheme> update(@Validated @RequestBody UserDGTheme data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("用户表格自定义[update]操作发生错误","UserDGTheme",data.getUserdgthemeid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<UserDGTheme> get(@Validated @PathVariable String id){
		UserDGTheme data=new UserDGTheme();
		data.setUserdgthemeid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("用户表格自定义[get]操作发生错误","UserDGTheme",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<UserDGTheme> getDraft(@Validated @RequestBody UserDGTheme data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("用户表格自定义[getDraft]操作发生错误","UserDGTheme","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<UserDGTheme> remove(@Validated @RequestBody UserDGTheme data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("用户表格自定义[remove]操作发生错误","UserDGTheme",data.getUserdgthemeid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<UserDGTheme> checkKey(@Validated @RequestBody UserDGTheme data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("用户表格自定义[checkKey]操作发生错误","UserDGTheme",data.getUserdgthemeid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<UserDGTheme> create(@Validated @RequestBody UserDGTheme data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("用户表格自定义[create]操作发生错误","UserDGTheme",data.getUserdgthemeid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<UserDGTheme>> searchDefaultPage(@Validated @RequestBody UserDGThemeSearchFilter filter){
		Page<UserDGTheme> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<UserDGTheme>> listDefault(@Validated @RequestBody UserDGThemeSearchFilter filter){
		List<UserDGTheme> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
